/** Copyright (C) 2017 by Bundesanstalt für Gewässerkunde
 * Software engineering by
 *  Björnsen Beratende Ingenieure GmbH
 *  Dr. Schumacher Ingenieurbüro für Wasser und Umwelt
 *
 * This file is Free Software under the GNU AGPL (>=v3)
 * and comes with ABSOLUTELY NO WARRANTY! Check out the
 * documentation coming with Dive4Elements River for details.
 */
package org.dive4elements.river.client.client.ui.uinfo;

import java.util.List;

import org.dive4elements.river.client.client.FLYSConstants;

import com.smartgwt.client.widgets.form.fields.TextItem;

/**
 * @author Domenico Nardi Tironi
 *
 */
public class UinfoInundationSingleYearEpochBehaviour extends ValidationBehaviourSingleMultiInputItem {

    private final String titleForCreateOld;

    public UinfoInundationSingleYearEpochBehaviour(final String appendString, final FLYSConstants msg, final String titleForCreateOld) {
        super(appendString, msg);
        this.titleForCreateOld = titleForCreateOld;
    }

    @Override
    public void appendValue(final TextItem inputItem, final String value) {
        inputItem.setValue(value);
    }

    @Override
    public List<String> validate(final List<String> errors, final String inputValueString) {
        boolean isGood = false;
        for (final String validYear : this.getValidInputs()) { // no numeric check
            /* No list contains for strings? */
            if (inputValueString.equals(validYear)) {
                isGood = true;
                break;
            }
        }
        if (!isGood) {
            String tmp = this.errorForItemMsg;
            tmp = tmp.replace("$1", inputValueString);
            errors.add(tmp);
        }

        return errors;

    }

    @Override
    public boolean isMultipleInputsAllowed() {
        return false;
    }

    @Override
    public String titleForCreateOld() {
        return this.titleForCreateOld;
    }
}
